/*
TRANSLATOR Tuxtalador2::BaseInstall
*/
/**
 * Tuxtalador2 -- Tuxtalador rewrite that helps with a system installation.
 * Copyright (C) 2008 Tuxum Secure Systems.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "baseinstall.h"

#include "../process.h"

using namespace Tuxtalador2;

BaseInstall::BaseInstall(ModuleManager *mm) : BaseModule(mm){
	mm->addWizard(this, 31);
}

QString BaseInstall::label(int step){
	return tr("Base system install");
}

QWidget *BaseInstall::wizard(int step){
	totalLines=60; // pure experimental value
	nPackages=0;

	process=new Process("debootstrap.sh",this,false,true);

	connect(process,SIGNAL(log(const QString &, QColor)), 
			this, SLOT(readStdout(const QString &, QColor)));

	return NULL;
}

/**
 * @short From stdout it guesses the progress
 */
void BaseInstall::readStdout(const QString &msg, QColor){
	if (msg.contains("Validating"))
		totalLines+=4;
	else if (totalLines>20){
		manager->partialProgress(nPackages*100/totalLines);
	}
	emit log(tr("Progress %1 * 100 / %2").arg(nPackages).arg(totalLines), QColor("blue"));
	nPackages++;
}
