/**
 * Tuxtalador2 -- Tuxtalador rewrite that helps with a system installation.
 * Copyright (C) 2008 Tuxum Secure Systems.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __BASE_INSTALL_H__
#define __BASE_INSTALL_H__

#include "../basemodule.h"


namespace Tuxtalador2{

	class Process;

	/**
 	 * @short Performs debootstrap install.
	 */
	class BaseInstall : public BaseModule{
		Q_OBJECT
	public:
		BaseInstall(ModuleManager *mm);
		QString label(int step);
		QWidget *wizard(int step);

		bool canContinueNow(int step){ return false; };

		bool canGoBack(int step){ return false; };

	protected slots:
		void readStdout(const QString &msg,QColor color);

	protected:
		Process *process;

		int nPackages;
		int totalLines;
	};
};

#endif

