/**
 * Tuxtalador2 -- Tuxtalador rewrite that helps with a system installation.
 * Copyright (C) 2008 Tuxum Secure Systems.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __INSTALL_H__
#define __INSTALL_H__

#include "../basemodule.h"

#include <QStringList>

class QLabel;

namespace Tuxtalador2{
	class Process;

	/**
	 * @short Performs the big package installation
	 */
	class Install : public BaseModule{
	Q_OBJECT
	public:
		Install(ModuleManager *);

		QWidget *wizard(int step);
		QString label(int step);
		bool canContinueNow(int step){ return false; }
		bool canGoBack(int step){ return false; }

	signals:
		void log(const QString &msg, QColor color);
	
	public slots:
		void installPackage();
		void installFinished(int);
		void readStdout(const QString &, QColor);

	protected:
		/// Nr packages already installed
		int packagesInstalled;
		/// total number of packages, from get, or ls.. or...
		int totalPackages;
		/// Packages to install, full list
		QStringList packages;
		/// Packages not installed yet
		QStringList packagesLeft;

		QLabel *currentPackageLabel;
		Process *process;
	};
};

#endif
