/*
TRANSLATOR Tuxtalador2::PostInstall
*/
/**
 * Tuxtalador2 -- Tuxtalador rewrite that helps with a system installation.
 * Copyright (C) 2008 Tuxum Secure Systems.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stdlib.h>
#include <sys/stat.h> 

#include <QFile>

#include "../process.h"

#include "postinstall.h"

using namespace Tuxtalador2;

PostInstall::PostInstall(ModuleManager *mm): BaseModule(mm){
	mm->addWizard(this, 93);
}

QWidget *PostInstall::wizard(int step){
	//manager->writeLog(tr("Set envvar ROOT_DEVICE=%1").arg(manager->getConfig("rootpartition")));
	foreach(QString s, manager->getConfigKeys()){
		setenv((char*)s.toUtf8().data(),(char*)manager->getConfig(s).toUtf8().data(),1);
		manager->writeLog(tr("Set envvar %1=%2").arg(s).arg(manager->getConfig(s)),QColor("purple"));
	}

	// Creating /dev entries...
	system("cp -a /dev/* /target/dev");

	mkdir("/target/tmp/postinstall",0777);
	system("cp -a " TI2_DIR "/postinstall/* /target/tmp/postinstall");

	if (!manager->getConfig("OEM").isEmpty()){ // OEM mode, must remove 
		// or normal
		if (manager->getConfig("firstBoot").isEmpty()){
			system("rm /target/tmp/postinstall/Z*");
		}
		// or system ready
		else{
			system("mkdir -p /tmp/postinstall/");
			system("cp /usr/share/apps/tuxtalador2/postinstall/Z* /tmp/postinstall/");
			new Process("run-parts -a install /tmp/postinstall/", this, false, true);
			return NULL;
		}
	} // if not OEM mode, must do everything.
	
	system("lsusb > /target/tmp/usb");

	new Process("chroot /target run-parts -a install /tmp/postinstall/", this, false, true);
	return NULL;
}

QString PostInstall::label(int step){
	return tr("Postinstall scripts");
}
