/**
 * Tuxtalador2 -- Tuxtalador rewrite that helps with a system installation.
 * Copyright (C) 2008 Tuxum Secure Systems.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __USERDATA_H__
#define __USERDATA_H__

#include "../basemodule.h"

class QLineEdit;
class QCheckBox;

namespace Tuxtalador2{
	
	/**
	 * @short Shows several pages: welcome, license and goodbye. 
	 *
	 * Nothing really important.
	 */
	class Userdata : public BaseModule{
	Q_OBJECT
	public:
		Userdata(ModuleManager *);

		QWidget *wizard(int step);
		QString label(int step);

		/// When at a new page, checks if it can continue.
		virtual bool canContinueNow(int step){ return false; };

	protected slots:
		void textChanged(const QString &);
		void autologinChanged(int);

	protected:
		QWidget *prepareAskForUserdata();
		QWidget *doSetUserdata();

	protected:
		QLineEdit *fullname;
		QLineEdit *username;

		QLineEdit *password;
		QLineEdit *passwordRepeat;

		QLineEdit *rootPassword;
		QLineEdit *rootPasswordRepeat;
		QLineEdit *hostname;
		
		QCheckBox *automaticLogin;

		QString sfullname;
		QString susername;
		QString spassword;
		QString srootPassword;
		QString shostname;
		bool bautologin;

	};
}


#endif
