/**
 * Tuxtalador2 -- Tuxtalador rewrite that helps with a system installation.
 * Copyright (C) 2008 Tuxum Secure Systems.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __WIZARD_H__
#define __WIZARD_H__

#include <QWidget>
#include <QListWidgetItem>

class QPushButton;
class QProgressBar;
class QGridLayout;
class QLabel;
class QListWidget;
class QListWidgetItem;
class QTextEdit;

namespace Tuxtalador2{
	class ModuleManager;
	class BaseModule;

	/**
	 * @short Main wizard class that shows the other wizards
	 *
	 * It also calls moduleManager as needed to do the wizard/installation 
	 * steps.
	 */
	class Wizard : public QWidget {
	Q_OBJECT
	public:
		Wizard(ModuleManager *moduleManager, QWidget *parent=NULL);

	protected slots:
		void setWizard(BaseModule *, int position);
		void doCancel();
		void canContinue(bool);
		void log(const QString &,QColor color);
		void openTerminal();
		void genericRun();
		void toggleFullscreen();
		
	protected:
		ModuleManager *moduleManager;

		QListWidget *sections;


		QPushButton *prev;
		QPushButton *next;
		QPushButton *cancel;

		QProgressBar *progress;
		QGridLayout *layout;
		QLabel *title;
			
		QWidget *wizard;
		QWidget *defaultWizard;

		QMap<QString,QListWidgetItem*> menuitems;

		QTextEdit *logPane;
	};
};

#endif
